# Import needed modules from osc4py3
# from osc4py3.as_eventloop import *
from osc4py3.as_allthreads import *
from osc4py3 import oscmethod as osm

def handlerfunction1(s, x, y):
    # Will receive message data unpacked in s, x, y
    print("{}, {}, {}".format(s,x,y))
    pass

def handlerfunctionflex(address, *args):
    # Will receive message data unpacked in s, x, y
    print("from: " + address + ": " + str(args))
    pass


def handlerfunction2(address, num):
    # Will receive message address, and message data flattened in s, x, y
    print("from: " + address)
    print(num)
    pass

# Start the system.
osc_startup()

# Make server channels to receive packets.
# osc_udp_server("192.168.0.0", 3721, "aservername")
osc_udp_server("127.0.0.1", 3721, "aservername")
# osc_udp_server("0.0.0.0", 3724, "anotherserver")
# osc_udp_server("127.0.0.1", 3724, "anotherserver")

# osc_method("/test/first", handlerfunction1)
osc_method("/position", handlerfunctionflex, argscheme=osm.OSCARG_ADDRESS + osm.OSCARG_DATAUNPACK)
osc_method("/sound/one", handlerfunctionflex, argscheme=osm.OSCARG_ADDRESS + osm.OSCARG_DATAUNPACK)
# # Too, but request the message address pattern before in argscheme
# osc_method("/test/second", handlerfunction2, argscheme=osm.OSCARG_ADDRESS + osm.OSCARG_DATAUNPACK)

while True:
    try:
        # wait for messages to come in...
        pass
    except KeyboardInterrupt:
        break

# Properly close the system.
osc_terminate()
